// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: cartographer/ground_truth/proto/relations.proto

#define INTERNAL_SUPPRESS_PROTOBUF_FIELD_DEPRECATION
#include "cartographer/ground_truth/proto/relations.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// @@protoc_insertion_point(includes)

namespace cartographer {
namespace ground_truth {
namespace proto {

namespace {

const ::google::protobuf::Descriptor* Relation_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  Relation_reflection_ = NULL;
const ::google::protobuf::Descriptor* GroundTruth_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  GroundTruth_reflection_ = NULL;

}  // namespace


void protobuf_AssignDesc_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto() {
  protobuf_AddDesc_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto();
  const ::google::protobuf::FileDescriptor* file =
    ::google::protobuf::DescriptorPool::generated_pool()->FindFileByName(
      "cartographer/ground_truth/proto/relations.proto");
  GOOGLE_CHECK(file != NULL);
  Relation_descriptor_ = file->message_type(0);
  static const int Relation_offsets_[3] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(Relation, timestamp1_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(Relation, timestamp2_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(Relation, expected_),
  };
  Relation_reflection_ =
    new ::google::protobuf::internal::GeneratedMessageReflection(
      Relation_descriptor_,
      Relation::default_instance_,
      Relation_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(Relation, _has_bits_[0]),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(Relation, _unknown_fields_),
      -1,
      ::google::protobuf::DescriptorPool::generated_pool(),
      ::google::protobuf::MessageFactory::generated_factory(),
      sizeof(Relation));
  GroundTruth_descriptor_ = file->message_type(1);
  static const int GroundTruth_offsets_[1] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GroundTruth, relation_),
  };
  GroundTruth_reflection_ =
    new ::google::protobuf::internal::GeneratedMessageReflection(
      GroundTruth_descriptor_,
      GroundTruth::default_instance_,
      GroundTruth_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GroundTruth, _has_bits_[0]),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(GroundTruth, _unknown_fields_),
      -1,
      ::google::protobuf::DescriptorPool::generated_pool(),
      ::google::protobuf::MessageFactory::generated_factory(),
      sizeof(GroundTruth));
}

namespace {

GOOGLE_PROTOBUF_DECLARE_ONCE(protobuf_AssignDescriptors_once_);
inline void protobuf_AssignDescriptorsOnce() {
  ::google::protobuf::GoogleOnceInit(&protobuf_AssignDescriptors_once_,
                 &protobuf_AssignDesc_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto);
}

void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
    Relation_descriptor_, &Relation::default_instance());
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
    GroundTruth_descriptor_, &GroundTruth::default_instance());
}

}  // namespace

void protobuf_ShutdownFile_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto() {
  delete Relation::default_instance_;
  delete Relation_reflection_;
  delete GroundTruth::default_instance_;
  delete GroundTruth_reflection_;
}

void protobuf_AddDesc_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto() {
  static bool already_here = false;
  if (already_here) return;
  already_here = true;
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  ::cartographer::transform::proto::protobuf_AddDesc_cartographer_2ftransform_2fproto_2ftransform_2eproto();
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
    "\n/cartographer/ground_truth/proto/relati"
    "ons.proto\022\037cartographer.ground_truth.pro"
    "to\032,cartographer/transform/proto/transfo"
    "rm.proto\"k\n\010Relation\022\022\n\ntimestamp1\030\001 \001(\003"
    "\022\022\n\ntimestamp2\030\002 \001(\003\0227\n\010expected\030\003 \001(\0132%"
    ".cartographer.transform.proto.Rigid3d\"J\n"
    "\013GroundTruth\022;\n\010relation\030\001 \003(\0132).cartogr"
    "apher.ground_truth.proto.Relation", 313);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "cartographer/ground_truth/proto/relations.proto", &protobuf_RegisterTypes);
  Relation::default_instance_ = new Relation();
  GroundTruth::default_instance_ = new GroundTruth();
  Relation::default_instance_->InitAsDefaultInstance();
  GroundTruth::default_instance_->InitAsDefaultInstance();
  ::google::protobuf::internal::OnShutdown(&protobuf_ShutdownFile_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto);
}

// Force AddDescriptors() to be called at static initialization time.
struct StaticDescriptorInitializer_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto {
  StaticDescriptorInitializer_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto() {
    protobuf_AddDesc_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto();
  }
} static_descriptor_initializer_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto_;

// ===================================================================

#ifndef _MSC_VER
const int Relation::kTimestamp1FieldNumber;
const int Relation::kTimestamp2FieldNumber;
const int Relation::kExpectedFieldNumber;
#endif  // !_MSC_VER

Relation::Relation()
  : ::google::protobuf::Message() {
  SharedCtor();
  // @@protoc_insertion_point(constructor:cartographer.ground_truth.proto.Relation)
}

void Relation::InitAsDefaultInstance() {
  expected_ = const_cast< ::cartographer::transform::proto::Rigid3d*>(&::cartographer::transform::proto::Rigid3d::default_instance());
}

Relation::Relation(const Relation& from)
  : ::google::protobuf::Message() {
  SharedCtor();
  MergeFrom(from);
  // @@protoc_insertion_point(copy_constructor:cartographer.ground_truth.proto.Relation)
}

void Relation::SharedCtor() {
  _cached_size_ = 0;
  timestamp1_ = GOOGLE_LONGLONG(0);
  timestamp2_ = GOOGLE_LONGLONG(0);
  expected_ = NULL;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

Relation::~Relation() {
  // @@protoc_insertion_point(destructor:cartographer.ground_truth.proto.Relation)
  SharedDtor();
}

void Relation::SharedDtor() {
  if (this != default_instance_) {
    delete expected_;
  }
}

void Relation::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* Relation::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return Relation_descriptor_;
}

const Relation& Relation::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto();
  return *default_instance_;
}

Relation* Relation::default_instance_ = NULL;

Relation* Relation::New() const {
  return new Relation;
}

void Relation::Clear() {
#define OFFSET_OF_FIELD_(f) (reinterpret_cast<char*>(      \
  &reinterpret_cast<Relation*>(16)->f) - \
   reinterpret_cast<char*>(16))

#define ZR_(first, last) do {                              \
    size_t f = OFFSET_OF_FIELD_(first);                    \
    size_t n = OFFSET_OF_FIELD_(last) - f + sizeof(last);  \
    ::memset(&first, 0, n);                                \
  } while (0)

  if (_has_bits_[0 / 32] & 7) {
    ZR_(timestamp1_, timestamp2_);
    if (has_expected()) {
      if (expected_ != NULL) expected_->::cartographer::transform::proto::Rigid3d::Clear();
    }
  }

#undef OFFSET_OF_FIELD_
#undef ZR_

  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  mutable_unknown_fields()->Clear();
}

bool Relation::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:cartographer.ground_truth.proto.Relation)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoff(127);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional int64 timestamp1 = 1;
      case 1: {
        if (tag == 8) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &timestamp1_)));
          set_has_timestamp1();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(16)) goto parse_timestamp2;
        break;
      }

      // optional int64 timestamp2 = 2;
      case 2: {
        if (tag == 16) {
         parse_timestamp2:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &timestamp2_)));
          set_has_timestamp2();
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(26)) goto parse_expected;
        break;
      }

      // optional .cartographer.transform.proto.Rigid3d expected = 3;
      case 3: {
        if (tag == 26) {
         parse_expected:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
               input, mutable_expected()));
        } else {
          goto handle_unusual;
        }
        if (input->ExpectAtEnd()) goto success;
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0 ||
            ::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:cartographer.ground_truth.proto.Relation)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:cartographer.ground_truth.proto.Relation)
  return false;
#undef DO_
}

void Relation::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:cartographer.ground_truth.proto.Relation)
  // optional int64 timestamp1 = 1;
  if (has_timestamp1()) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(1, this->timestamp1(), output);
  }

  // optional int64 timestamp2 = 2;
  if (has_timestamp2()) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(2, this->timestamp2(), output);
  }

  // optional .cartographer.transform.proto.Rigid3d expected = 3;
  if (has_expected()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      3, this->expected(), output);
  }

  if (!unknown_fields().empty()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:cartographer.ground_truth.proto.Relation)
}

::google::protobuf::uint8* Relation::SerializeWithCachedSizesToArray(
    ::google::protobuf::uint8* target) const {
  // @@protoc_insertion_point(serialize_to_array_start:cartographer.ground_truth.proto.Relation)
  // optional int64 timestamp1 = 1;
  if (has_timestamp1()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(1, this->timestamp1(), target);
  }

  // optional int64 timestamp2 = 2;
  if (has_timestamp2()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(2, this->timestamp2(), target);
  }

  // optional .cartographer.transform.proto.Rigid3d expected = 3;
  if (has_expected()) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteMessageNoVirtualToArray(
        3, this->expected(), target);
  }

  if (!unknown_fields().empty()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:cartographer.ground_truth.proto.Relation)
  return target;
}

int Relation::ByteSize() const {
  int total_size = 0;

  if (_has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    // optional int64 timestamp1 = 1;
    if (has_timestamp1()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int64Size(
          this->timestamp1());
    }

    // optional int64 timestamp2 = 2;
    if (has_timestamp2()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int64Size(
          this->timestamp2());
    }

    // optional .cartographer.transform.proto.Rigid3d expected = 3;
    if (has_expected()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
          this->expected());
    }

  }
  if (!unknown_fields().empty()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void Relation::MergeFrom(const ::google::protobuf::Message& from) {
  GOOGLE_CHECK_NE(&from, this);
  const Relation* source =
    ::google::protobuf::internal::dynamic_cast_if_available<const Relation*>(
      &from);
  if (source == NULL) {
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
    MergeFrom(*source);
  }
}

void Relation::MergeFrom(const Relation& from) {
  GOOGLE_CHECK_NE(&from, this);
  if (from._has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    if (from.has_timestamp1()) {
      set_timestamp1(from.timestamp1());
    }
    if (from.has_timestamp2()) {
      set_timestamp2(from.timestamp2());
    }
    if (from.has_expected()) {
      mutable_expected()->::cartographer::transform::proto::Rigid3d::MergeFrom(from.expected());
    }
  }
  mutable_unknown_fields()->MergeFrom(from.unknown_fields());
}

void Relation::CopyFrom(const ::google::protobuf::Message& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void Relation::CopyFrom(const Relation& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool Relation::IsInitialized() const {

  return true;
}

void Relation::Swap(Relation* other) {
  if (other != this) {
    std::swap(timestamp1_, other->timestamp1_);
    std::swap(timestamp2_, other->timestamp2_);
    std::swap(expected_, other->expected_);
    std::swap(_has_bits_[0], other->_has_bits_[0]);
    _unknown_fields_.Swap(&other->_unknown_fields_);
    std::swap(_cached_size_, other->_cached_size_);
  }
}

::google::protobuf::Metadata Relation::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = Relation_descriptor_;
  metadata.reflection = Relation_reflection_;
  return metadata;
}


// ===================================================================

#ifndef _MSC_VER
const int GroundTruth::kRelationFieldNumber;
#endif  // !_MSC_VER

GroundTruth::GroundTruth()
  : ::google::protobuf::Message() {
  SharedCtor();
  // @@protoc_insertion_point(constructor:cartographer.ground_truth.proto.GroundTruth)
}

void GroundTruth::InitAsDefaultInstance() {
}

GroundTruth::GroundTruth(const GroundTruth& from)
  : ::google::protobuf::Message() {
  SharedCtor();
  MergeFrom(from);
  // @@protoc_insertion_point(copy_constructor:cartographer.ground_truth.proto.GroundTruth)
}

void GroundTruth::SharedCtor() {
  _cached_size_ = 0;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

GroundTruth::~GroundTruth() {
  // @@protoc_insertion_point(destructor:cartographer.ground_truth.proto.GroundTruth)
  SharedDtor();
}

void GroundTruth::SharedDtor() {
  if (this != default_instance_) {
  }
}

void GroundTruth::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* GroundTruth::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return GroundTruth_descriptor_;
}

const GroundTruth& GroundTruth::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_cartographer_2fground_5ftruth_2fproto_2frelations_2eproto();
  return *default_instance_;
}

GroundTruth* GroundTruth::default_instance_ = NULL;

GroundTruth* GroundTruth::New() const {
  return new GroundTruth;
}

void GroundTruth::Clear() {
  relation_.Clear();
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  mutable_unknown_fields()->Clear();
}

bool GroundTruth::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:cartographer.ground_truth.proto.GroundTruth)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoff(127);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .cartographer.ground_truth.proto.Relation relation = 1;
      case 1: {
        if (tag == 10) {
         parse_relation:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
                input, add_relation()));
        } else {
          goto handle_unusual;
        }
        if (input->ExpectTag(10)) goto parse_relation;
        if (input->ExpectAtEnd()) goto success;
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0 ||
            ::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:cartographer.ground_truth.proto.GroundTruth)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:cartographer.ground_truth.proto.GroundTruth)
  return false;
#undef DO_
}

void GroundTruth::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:cartographer.ground_truth.proto.GroundTruth)
  // repeated .cartographer.ground_truth.proto.Relation relation = 1;
  for (int i = 0; i < this->relation_size(); i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->relation(i), output);
  }

  if (!unknown_fields().empty()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:cartographer.ground_truth.proto.GroundTruth)
}

::google::protobuf::uint8* GroundTruth::SerializeWithCachedSizesToArray(
    ::google::protobuf::uint8* target) const {
  // @@protoc_insertion_point(serialize_to_array_start:cartographer.ground_truth.proto.GroundTruth)
  // repeated .cartographer.ground_truth.proto.Relation relation = 1;
  for (int i = 0; i < this->relation_size(); i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteMessageNoVirtualToArray(
        1, this->relation(i), target);
  }

  if (!unknown_fields().empty()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:cartographer.ground_truth.proto.GroundTruth)
  return target;
}

int GroundTruth::ByteSize() const {
  int total_size = 0;

  // repeated .cartographer.ground_truth.proto.Relation relation = 1;
  total_size += 1 * this->relation_size();
  for (int i = 0; i < this->relation_size(); i++) {
    total_size +=
      ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
        this->relation(i));
  }

  if (!unknown_fields().empty()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void GroundTruth::MergeFrom(const ::google::protobuf::Message& from) {
  GOOGLE_CHECK_NE(&from, this);
  const GroundTruth* source =
    ::google::protobuf::internal::dynamic_cast_if_available<const GroundTruth*>(
      &from);
  if (source == NULL) {
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
    MergeFrom(*source);
  }
}

void GroundTruth::MergeFrom(const GroundTruth& from) {
  GOOGLE_CHECK_NE(&from, this);
  relation_.MergeFrom(from.relation_);
  mutable_unknown_fields()->MergeFrom(from.unknown_fields());
}

void GroundTruth::CopyFrom(const ::google::protobuf::Message& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void GroundTruth::CopyFrom(const GroundTruth& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool GroundTruth::IsInitialized() const {

  return true;
}

void GroundTruth::Swap(GroundTruth* other) {
  if (other != this) {
    relation_.Swap(&other->relation_);
    std::swap(_has_bits_[0], other->_has_bits_[0]);
    _unknown_fields_.Swap(&other->_unknown_fields_);
    std::swap(_cached_size_, other->_cached_size_);
  }
}

::google::protobuf::Metadata GroundTruth::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = GroundTruth_descriptor_;
  metadata.reflection = GroundTruth_reflection_;
  return metadata;
}


// @@protoc_insertion_point(namespace_scope)

}  // namespace proto
}  // namespace ground_truth
}  // namespace cartographer

// @@protoc_insertion_point(global_scope)
